<?php

use \Elementor\Controls_Manager;

add_action(
	'elementor/element/editor-preferences/preferences/before_section_end',
	function( $stack ) {
		$stack->add_control(
			'edp_quick_spacers_enable',
			[
				'label'       => __( 'Enable Quick Spacers', 'spacer-elementor' ),
				'description' => __( 'Use `Ctrl/Cmd + Q` shortcut to toggle', 'spacer-elementor' ),
				'type'        => Controls_Manager::SWITCHER,
				'default'     => 'yes',
			]
		);
	},
	10, 2
);
