"use strict";
function _defineProperty(e, t, r) {
    return t in e ? Object.defineProperty(e, t, { value: r, enumerable: !0, configurable: !0, writable: !0 }) : (e[t] = r), e;
}
function _typeof(e) {
    return (_typeof =
        "function" == typeof Symbol && "symbol" == typeof Symbol.iterator
            ? function (e) {
                  return typeof e;
              }
            : function (e) {
                  return e && "function" == typeof Symbol && e.constructor === Symbol && e !== Symbol.prototype ? "symbol" : typeof e;
              })(e);
}
function _classCallCheck(e, t) {
    if (!(e instanceof t)) throw new TypeError("Cannot call a class as a function");
}
function _defineProperties(e, t) {
    for (var r = 0; r < t.length; r++) {
        var n = t[r];
        (n.enumerable = n.enumerable || !1), (n.configurable = !0), "value" in n && (n.writable = !0), Object.defineProperty(e, n.key, n);
    }
}
function _createClass(e, t, r) {
    return t && _defineProperties(e.prototype, t), r && _defineProperties(e, r), e;
}
function _get(e, t, r) {
    return (_get =
        "undefined" != typeof Reflect && Reflect.get
            ? Reflect.get
            : function (e, t, r) {
                  var n = _superPropBase(e, t);
                  if (n) {
                      var i = Object.getOwnPropertyDescriptor(n, t);
                      return i.get ? i.get.call(r) : i.value;
                  }
              })(e, t, r || e);
}
function _superPropBase(e, t) {
    for (; !Object.prototype.hasOwnProperty.call(e, t) && null !== (e = _getPrototypeOf(e)); );
    return e;
}
function _inherits(e, t) {
    if ("function" != typeof t && null !== t) throw new TypeError("Super expression must either be null or a function");
    (e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } })), t && _setPrototypeOf(e, t);
}
function _setPrototypeOf(e, t) {
    return (_setPrototypeOf =
        Object.setPrototypeOf ||
        function (e, t) {
            return (e.__proto__ = t), e;
        })(e, t);
}
function _createSuper(n) {
    var i = _isNativeReflectConstruct();
    return function () {
        var e,
            t = _getPrototypeOf(n);
        if (i) {
            var r = _getPrototypeOf(this).constructor;
            e = Reflect.construct(t, arguments, r);
        } else e = t.apply(this, arguments);
        return _possibleConstructorReturn(this, e);
    };
}
function _possibleConstructorReturn(e, t) {
    return !t || ("object" !== _typeof(t) && "function" != typeof t) ? _assertThisInitialized(e) : t;
}
function _assertThisInitialized(e) {
    if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    return e;
}
function _isNativeReflectConstruct() {
    if ("undefined" == typeof Reflect || !Reflect.construct) return !1;
    if (Reflect.construct.sham) return !1;
    if ("function" == typeof Proxy) return !0;
    try {
        return Date.prototype.toString.call(Reflect.construct(Date, [], function () {})), !0;
    } catch (e) {
        return !1;
    }
}
function _getPrototypeOf(e) {
    return (_getPrototypeOf = Object.setPrototypeOf
        ? Object.getPrototypeOf
        : function (e) {
              return e.__proto__ || Object.getPrototypeOf(e);
          })(e);
}
var edpSpacerBehavior = (function () {
    _inherits(o, Marionette.Behavior);
    var i = _createSuper(o);
    function o() {
        var e;
        _classCallCheck(this, o);
        for (var t = arguments.length, r = new Array(t), n = 0; n < t; n++) r[n] = arguments[n];
        return (
            ((e = i.call.apply(i, [this].concat(r))).onSettingsChange = _.debounce(function (e) {
                var t = this;
                if ("object" !== _typeof(e)) throw "Wrong settingsModel";
                if (this.defaults.edpSpacerDivs.length) {
                    var r = Object.keys(e.changed)[0];
                    if (
                        r &&
                        ["padding", "margin"].some(function (e) {
                            return r.includes(e);
                        })
                    ) {
                        var n = e.changed[r],
                            i = r.match(/[a-z]+/i)[0];
                        _.defer(function () {
                            return t.spacerStyleforProp(i, n);
                        });
                    }
                }
            }, 200)),
            e
        );
    }
    return (
        _createClass(o, [
            {
                key: "events",
                value: function () {
                    return { "mousedown .edp-spacer--active": "onDragStart" };
                },
            },
            {
                key: "defaults",
                value: function () {
                    return { spacerDivSize: 9, edpSpacerDivs: [] };
                },
            },
            {
                key: "initialize",
                value: function () {
                    var e = this;
                    _get(_getPrototypeOf(o.prototype), "initialize", this).call(this),
                        _.defer(function () {
                            e.listenTo(elementor.settings.editorPreferences.model, "change:edp_quick_spacers_enable", e.toggleSpacerVisibility),
                                e.isSpacerEnabled() && e.setListeners(),
                                (e.view.model.rszInstanceId = "rsz_" + e.$el.data("model-cid"));
                        });
                },
            },
            {
                key: "setListeners",
                value: function () {
                    this.listenTo(elementor.channels.dataEditMode, "switch", this.onEditModeSwitched),
                        this.listenTo(elementor.channels.deviceMode, "change", this.onDeviceModeChange),
                        this.listenTo(this.view.model.get("settings"), "change", this.onSettingsChange);
                },
            },
            {
                key: "removeListeners",
                value: function () {
                    this.stopListening(elementor.channels.dataEditMode, "switch", this.onEditModeSwitched),
                        this.stopListening(elementor.channels.deviceMode, "change", this.onDeviceModeChange),
                        this.stopListening(this.view.model.get("settings"), "change", this.onSettingsChange);
                },
            },
            {
                key: "toggleSpacerVisibility",
                value: function (e) {
                    "yes" === e.attributes.edp_quick_spacers_enable ? (this.setListeners(), this.onRender()) : this.onBeforeDestroy();
                },
            },
            {
                key: "onRender",
                value: function () {
                    var e = this;
                    _.defer(function () {
                        e.isSpacerEnabled() && ((e.defaults.edpSpacerDivs = []), e.addSpacers(), e.onEditModeSwitched(elementor.channels.dataEditMode.request("activeMode")));
                    });
                },
            },
            {
                key: "onEditModeSwitched",
                value: function (e) {
                    var t = this;
                    "edit" === e && "panel/global/style" !== this.getPanelRoute()
                        ? _.defer(function () {
                              return t.activate();
                          })
                        : this.$(".edp-spacer--active").length && this.deactivate();
                },
            },
            {
                key: "activate",
                value: function () {
                    var e = this;
                    this.$(".edp-spacer").addClass("edp-spacer--active"),
                        _.defer(function () {
                            return e.initSpacerStyle();
                        });
                },
            },
            {
                key: "deactivate",
                value: function () {
                    this.$(".edp-spacer--active").removeClass("edp-spacer--active");
                },
            },
            {
                key: "onBeforeDestroy",
                value: function () {
                    (this.defaults.edpSpacerDivs = []), this.removeListeners(), this.$(".edp-spacers-wrapper").remove();
                },
            },
            {
                key: "onDeviceModeChange",
                value: function () {
                    var e = this;
                    _.defer(function () {
                        return e.initSpacerStyle();
                    });
                },
            },
            {
                key: "addSpacers",
                value: function () {
                    var r = this;
                    this.spacerContainer = this.getSpacerContainer();
                    var e = this.getElementType();
                    if (this.spacerContainer.length)
                        if (this.spacerContainer.find("> .edp-spacers-wrapper").length) console.error("spacers already exist for", e, this.$el.data("model-cid"));
                        else {
                            var n,
                                i = e.charAt(0),
                                o = document.createDocumentFragment(),
                                t = document.createElement("div");
                            t.setAttribute("class", "edp-spacers-wrapper"),
                                ["padding", "margin"].forEach(function (t) {
                                    r.getSpacerDimensions(t).forEach(function (e) {
                                        (n = document.createElement("div")),
                                            r.setAttributes(n, {
                                                class: "edp-spacer",
                                                "data-prop": t,
                                                "data-dim": e,
                                                "data-el-type": i,
                                                "data-rsz-side": r.getResizeSide(e),
                                                "data-axis": "height" === r.getResizableProp(e) ? "y" : "x",
                                                "data-val": 0,
                                            }),
                                            r.defaults.edpSpacerDivs.push(n),
                                            o.appendChild(n);
                                    });
                                }),
                                t.appendChild(o),
                                this.spacerContainer.prepend(t);
                        }
                    else console.error("container for spacers not found to add for", e, this.$el.data("model-cid"));
                },
            },
            {
                key: "initSpacerStyle",
                value: function () {
                    var n = this;
                    this.spacerContainer && this.spacerContainer.length
                        ? ["padding", "margin"].forEach(function (e) {
                              var t = n.getSpacerPropertyID(e),
                                  r = n.view.model.getSetting(t);
                              n.spacerStyleforProp(e, r);
                          })
                        : console.error("container not found to init spacer style", this.getElementType(), this.$el.data("model-cid"));
                },
            },
            {
                key: "spacerStyleforProp",
                value: function (e, t) {
                    var r = this,
                        n = this.getSpacerDimensions(e),
                        i = !1,
                        o = !1;
                    n.forEach(function (e) {
                        "" !== t[e] || (o = !0);
                    }),
                        "desktop" !== this.getCurrentDevice() && o
                            ? ((i = !0),
                              _.delay(function () {
                                  r.spacerStyleDimLoop(e, t, n, i);
                              }, 500))
                            : this.spacerStyleDimLoop(e, t, n, i);
                },
            },
            {
                key: "spacerStyleDimLoop",
                value: function (n, i, e, o) {
                    var a = this;
                    e.forEach(function (e) {
                        var t = i[e];
                        if (o) {
                            var r = parseInt(a.spacerContainer.css(n + "-" + e), 10);
                            r && (t = r);
                        }
                        a.setSpacerStyle(n, e, t, o);
                    });
                },
            },
            {
                key: "setSpacerStyle",
                value: function (e, t, r, n) {
                    var i = 3 < arguments.length && void 0 !== n && n,
                        o = "" === r ? this.defaults.spacerDivSize : r;
                    (!o || this.defaults.spacerDivSize > o) && (o = this.defaults.spacerDivSize);
                    var a = jQuery(this.defaults.edpSpacerDivs).siblings('[data-prop="' + e + '"][data-dim="' + t + '"]');
                    a.attr({ "data-val": r, style: "--edp-abs-val:" + o + "px" }), i ? a.addClass("hide-val") : a.removeClass("hide-val");
                },
            },
            {
                key: "onDragStart",
                value: function (e) {
                    if ((e.stopPropagation(), e.preventDefault(), window.edpIframeDoc)) {
                        var t = this,
                            r = e.currentTarget.dataset,
                            n = {
                                attr: r,
                                pos: "x" === r.axis ? e.clientX : e.clientY,
                                oldVal: r.val ? parseInt(r.val) : 0,
                                spacerContainer: this.spacerContainer,
                                el: e.currentTarget,
                                lowLimit: "margin" === r.prop ? -300 : 0,
                                upperLimit: 300,
                            };
                        jQuery(this.defaults.edpSpacerDivs)
                            .siblings("[data-prop=" + r.prop + "]")
                            .removeClass("hide-val"),
                            (window.isEdpDragging = !0),
                            this.setBodyCursor(r.dim),
                            "s" === r.elType && this.spacerContainer.find(".elementor-element-overlay .elementor-editor-element-settings").css("display", "none"),
                            jQuery(window.edpIframeDoc).find(".elementor-inline-editing.pen[contenteditable=true]").blur(),
                            jQuery(window.edpIframeDoc).find(".edp-spacer").not(e.currentTarget).removeClass("edp-spacer--active"),
                            jQuery(window.edpIframeDoc).on("mousemove." + this.view.model.rszInstanceId, function (e) {
                                t.onDrag(e, n);
                            }),
                            jQuery(window.edpIframeDoc).on("mouseup." + this.view.model.rszInstanceId, function (e) {
                                t.onDragEnd(e, n);
                            });
                    } else console.error("iFrame document not defined. Please report this to Designer Spacer's developer with a screenshot of this error.");
                },
            },
            {
                key: "onDrag",
                value: function (e, t) {
                    var r,
                        n,
                        i = this,
                        o = "x" === t.attr.axis ? e.clientX : e.clientY,
                        a = "edp-spacer--negative",
                        s = "edp-spacer--dragging",
                        c = "";
                    if (
                        (jQuery(t.spacerContainer).css(t.attr.prop, ""),
                        (r = ["left", "top"].includes(t.attr.rszSide) ? t.oldVal - o + t.pos : t.oldVal + o - t.pos),
                        t.upperLimit < r ? (r = t.upperLimit) : t.lowLimit > r && (r = t.lowLimit),
                        (t.newVal = r),
                        (n = Math.abs(r)) < this.defaults.spacerDivSize && (n = this.defaults.spacerDivSize),
                        r < 0 ? (s += " ".concat(a)) : (c = a),
                        e.shiftKey)
                    )
                        (s += " edp-spacer--active"),
                            jQuery(this.defaults.edpSpacerDivs)
                                .siblings('[data-prop="' + t.attr.prop + '"]')
                                .addClass(s)
                                .removeClass(c)
                                .attr({ "data-val": r, style: "--edp-abs-val:" + n + "px" }),
                            "s" === t.attr.elType && "margin" === t.attr.prop ? jQuery(t.spacerContainer).css({ "margin-top": r, "margin-bottom": r }) : jQuery(t.spacerContainer).css(t.attr.prop, r);
                    else if (e.altKey) {
                        (s += " edp-spacer--active"),
                            this.getOppositeSides(t.attr.dim).forEach(function (e) {
                                jQuery(i.defaults.edpSpacerDivs)
                                    .siblings('[data-prop="' + t.attr.prop + '"][data-dim="' + e + '"]')
                                    .addClass(s)
                                    .removeClass(c)
                                    .attr({ "data-val": r, style: "--edp-abs-val:" + n + "px" }),
                                    jQuery(t.spacerContainer).css(t.attr.prop + "-" + e, r);
                            });
                    } else
                        e.ctrlKey || e.metaKey
                            ? (jQuery(this.defaults.edpSpacerDivs)
                                  .siblings('[data-prop="' + t.attr.prop + '"]')
                                  .removeClass(c)
                                  .attr({ "data-val": 0, style: "--edp-abs-val:" + n + "px" }),
                              jQuery(t.spacerContainer).css(t.attr.prop, ""))
                            : (jQuery(t.el)
                                  .addClass(s)
                                  .removeClass(c)
                                  .attr({ "data-val": r, style: "--edp-abs-val:" + n + "px" }),
                              jQuery(t.spacerContainer).css(t.attr.prop + "-" + t.attr.dim, r));
                },
            },
            {
                key: "onDragEnd",
                value: function (e, t) {
                    var r = this;
                    e.stopPropagation(),
                        e.preventDefault(),
                        (window.isEdpDragging = !1),
                        this.setBodyCursor(t.attr.dim),
                        jQuery(window.edpIframeDoc).off("mousemove." + this.view.model.rszInstanceId),
                        jQuery(window.edpIframeDoc).off("mouseup." + this.view.model.rszInstanceId),
                        jQuery(window.edpIframeDoc).find(".edp-spacer").addClass("edp-spacer--active"),
                        this.$(".edp-spacer").removeClass("edp-spacer--dragging");
                    var n = this.getSpacerPropertyID(t.attr.prop),
                        i = this.view.model.getSetting(n);
                    if (("s" === t.attr.elType && this.spacerContainer.find(".elementor-element-overlay .elementor-editor-element-settings").css("display", ""), "undefined" !== t.newVal && "number" == typeof t.newVal)) {
                        var o = t.newVal.toString(),
                            a = "desktop" === this.getCurrentDevice(),
                            s = _.clone(i);
                        if (((s.unit = "px"), (s.isLinked = !1), e.ctrlKey || e.metaKey))
                            (s.isLinked = !0),
                                this.getSpacerDimensions(t.attr.prop).forEach(function (e) {
                                    s[e] = "";
                                });
                        else if (
                            (e.shiftKey ||
                                this.getSpacerDimensions(t.attr.prop).forEach(function (e) {
                                    "" === s[e] && (s[e] = a ? "0" : parseInt(r.spacerContainer.css(t.attr.prop + "-" + e), 10));
                                }),
                            e.altKey)
                        )
                            this.getOppositeSides(t.attr.dim).forEach(function (e) {
                                s[e] = o;
                            });
                        else
                            e.shiftKey
                                ? ((s.isLinked = !0),
                                  this.getSpacerDimensions(t.attr.prop).forEach(function (e) {
                                      s[e] = o;
                                  }))
                                : (s[t.attr.dim] = o);
                        _.isEqual(s, i) ? this.spacerStyleforProp(t.attr.prop, s) : this.applyElementorSpacingSettings(n, s), jQuery(t.spacerContainer).css(_defineProperty({}, t.attr.prop, ""));
                    } else this.spacerStyleforProp(t.attr.prop, i);
                },
            },
            {
                key: "applyElementorSpacingSettings",
                value: function (e, t) {
                    $e.run("document/elements/settings", { container: this.view.getContainer(), settings: _defineProperty({}, e, t), options: { external: !0 } });
                },
            },
            {
                key: "isSpacerEnabled",
                value: function () {
                    return "yes" === elementor.settings.editorPreferences.model.get("edp_quick_spacers_enable");
                },
            },
            {
                key: "getElementType",
                value: function () {
                    return this.view.model.get("elType");
                },
            },
            {
                key: "isColumn",
                value: function () {
                    return "column" === this.getElementType();
                },
            },
            {
                key: "isWidget",
                value: function () {
                    return "widget" === this.getElementType();
                },
            },
            {
                key: "getCurrentDevice",
                value: function () {
                    return elementor.channels.deviceMode.request("currentMode");
                },
            },
            {
                key: "getDeviceSuffix",
                value: function () {
                    var e = this.getCurrentDevice();
                    return "desktop" === e ? "" : "_" + e;
                },
            },
            {
                key: "getSpacerProperties",
                value: function () {
                    return ["padding", "margin"];
                },
            },
            {
                key: "getSpacerDimensions",
                value: function (e) {
                    return "margin" === e && "section" === this.getElementType() ? ["top", "bottom"] : ["top", "bottom", "right", "left"];
                },
            },
            {
                key: "getOppositeSides",
                value: function (e) {
                    return ["top", "bottom"].includes(e) ? ["top", "bottom"] : ["left", "right"];
                },
            },
            {
                key: "getOppositeResizeProp",
                value: function (e) {
                    return "height" === e ? "width" : "height";
                },
            },
            {
                key: "getOppositeDimension",
                value: function (e) {
                    switch (e) {
                        case "top":
                            return "bottom";
                        case "bottom":
                            return "top";
                        case "left":
                            return "right";
                        case "right":
                            return "left";
                    }
                },
            },
            {
                key: "getResizableProp",
                value: function (e) {
                    return ["top", "bottom"].includes(e) ? "height" : "width";
                },
            },
            {
                key: "getResizeSide",
                value: function (e) {
                    return ["top", "bottom"].includes(e) ? "bottom" : this.getOppositeDimension(e);
                },
            },
            {
                key: "getSpacerContainer",
                value: function () {
                    var e = edpGetSpacersElementSelector(this.getElementType());
                    return "" !== e ? this.$el.find(e).eq(0) : this.$el;
                },
            },
            {
                key: "getSpacerPropertyID",
                value: function (e) {
                    var t = this.getDeviceSuffix();
                    return (this.isWidget() ? "_" + e : e) + t;
                },
            },
            {
                key: "setAttributes",
                value: function (t, r) {
                    Object.keys(r).forEach(function (e) {
                        return t.setAttribute(e, r[e]);
                    });
                },
            },
            {
                key: "getPanelRoute",
                value: function () {
                    return elementor.documents.getCurrent().config.panel.default_route;
                },
            },
            {
                key: "setBodyCursor",
                value: function (e) {
                    var t = "ns-resize";
                    switch (e) {
                        case "right":
                        case "left":
                            t = "ew-resize";
                    }
                    window.isEdpDragging ? (window.edpIframeDoc.body.style.cursor = t) : (window.edpIframeDoc.body.style.cursor = "");
                },
            },
        ]),
        o
    );
})();
function edpGetSpacersElementSelector() {
    switch (0 < arguments.length && void 0 !== arguments[0] ? arguments[0] : "widget") {
        case "section":
            return "";
        case "column":
            return ".elementor-column-wrap";
        case "widget":
            return ".x-elementor-widget-container";
        default:
            return "";
    }
}
elementor.hooks.addFilter("elements/base/behaviors", function (e, t) {
    return (e.edpSpacer = { behaviorClass: edpSpacerBehavior }), e;
}),
    elementor.on("document:loaded", function () {
        window.edpIframeDoc = jQuery(document).find("#elementor-preview-iframe")[0].contentWindow.document;
    }),
    elementor.hooks.addFilter("panel/elements/regionViews", function (e) {
        return (
            _.defer(function () {
                setTimeout(function () {
                    e.search.region.currentView && e.search.region.currentView.ui.input.is(":focus") && e.search.region.currentView.ui.input.blur();
                });
            }),
            e
        );
    }),
    (document.querySelector("#elementor-preview-iframe").onload = function (e) {
        function t() {
            document.addEventListener("keydown", r), window.edpIframeDoc.addEventListener("keydown", r);
        }
        function r(e) {
            if (!e.repeat && ["KeyS", "KeyW", "KeyC"].includes(e.code)) {
                var t = e.code.substr(-1).toLowerCase();
                jQuery(window.edpIframeDoc).find(".edp-spacer[data-el-type!='".concat(t, "']")).removeClass("edp-spacer--active"),
                    e.target.addEventListener(
                        "keyup",
                        function (e) {
                            window.isEdpDragging || jQuery(window.edpIframeDoc).find(".edp-spacer[data-el-type!='".concat(t, "']")).addClass("edp-spacer--active");
                        },
                        { once: !0 }
                    );
            }
        }
        (window.edpIframeDoc = e.target.contentWindow.document),
            t(),
            elementor.on("edp/spacers/toggle", function (e) {
                e ? t() : (document.removeEventListener("keydown", r), window.edpIframeDoc.removeEventListener("keydown", r));
            });
    });
