<?php

use \Elementor\Controls_Manager;

add_action( 'elementor/element/editor-preferences/preferences/before_section_end', function( $stack ) {
	$stack->add_control( 'easymode', [
		'label'       => __( 'Easy Mode', 'yansir-b2b' ),
		'type'        => Controls_Manager::SWITCHER,
		'default'     => 'yes'
	] );
}, 20, 2 );

add_action( 'elementor/editor/after_enqueue_scripts', function() {
	wp_enqueue_script(
		'easymode',
		plugin_dir_url( __FILE__ ) . 'easymode.js',
		[ 'elementor-editor' ],
		false,
		true
	);

	wp_enqueue_style(
		'easymode',
		plugin_dir_url( __FILE__ ) . 'easymode.css',
		[],
		false
	);
} );

