<?php

require_once SPACER_PLUGIN_PATH . 'spacer/controls.php';

add_action(
	'elementor/editor/after_enqueue_scripts',
	function() {

		wp_register_script(
			'edp-spacer-editor',
			SPACER_PLUGIN_URL . 'spacer/editor.min.js',
			[ 'elementor-editor' ],
			Spacer_For_Elementor::VERSION,
			true
		);

		wp_enqueue_script( 'edp-spacer-editor' );

	}
);

add_action(
	'elementor/preview/enqueue_styles',
	function() {
		wp_enqueue_style(
			'edp-spacer',
			SPACER_PLUGIN_URL . 'spacer/preview.min.css',
			[],
			Spacer_For_Elementor::VERSION
		);
	}
);
